// Speex.cpp: implementation of the CSpeex class.
//
//////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "Speex.h"
#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////


CSpeex::CSpeex()
{
    mEncode  = speex_encoder_init(&speex_nb_mode);
	mDecode  = speex_decoder_init(&speex_nb_mode);
    int vad  = 1;
	speex_bits_init(&mBits);
	speex_bits_init(&dBits);
    speex_encoder_ctl(mEncode, SPEEX_SET_VAD, &vad);
}

CSpeex::~CSpeex()
{
	speex_bits_destroy(&mBits);
	speex_bits_destroy(&dBits);
	speex_encoder_destroy(mEncode);
	speex_decoder_destroy(mDecode);
}


// Pass 38 bytes encoded array to this function
// The decoded character array is 320 bytes long character array is
// returned to the calling function
char *CSpeex::decode(char *buffer, int encodeSize)
{
   char *decodedBuffer = new char[FRAMESIZE+1];
   short speexShort;

   float speexFloat[FRAMESIZE+1];

      // Decode the sound data into a float buffer
   speex_bits_reset(&dBits);

   speex_bits_read_from(&dBits, buffer, encodeSize);

   speex_decode(mDecode, &dBits, speexFloat);

   // Convert from float to short to char
   for (int i = 0, j=0; i < FRAMESIZE/2; i++, j++)
      {
            speexShort = (short)speexFloat[i];
            memcpy(&decodedBuffer[j*2], &speexShort, sizeof(short));
      }
   /*delete[] speexFloat;
   speexFloat = 0; */
   // Return the buffer

   return decodedBuffer;
}


// Pass 320 bytes long character array to this function.
// The encoded character array is 38 bytes long.
char *CSpeex::encode(char *buffer, int &encodeSize)
{
	char    *encodedBuffer = new char[FRAMESIZE/2+1];
    short   speexShort;
	float   speexFloat[FRAMESIZE/2+1];

    // Convert the audio to a short then to a float buffer
    for (int i = 0; i < FRAMESIZE/2; i++) {
		memcpy(&speexShort, &buffer[i*2], sizeof(short));
		speexFloat[i] = speexShort; 
		//speexFloat[i] = (float)(*(short*)&buffer[i*2]);

     }
	// Encode the sound data using the float buffer
 
    speex_bits_reset(&mBits);
    speex_encode(mEncode, speexFloat, &mBits);
    encodeSize = speex_bits_write(&mBits, encodedBuffer, FRAMESIZE/2);

    //delete[] speexFloat;

    //speexFloat = 0;
    // Return the encoded buffer
    return encodedBuffer;
}





